import PropTypes from 'prop-types';
import { ItemProps } from './types';
/**
 * Gallery item
 *
 * Should be a children of Gallery component
 */
export declare const Item: {
    <NodeType extends HTMLElement>({ children, ...restProps }: ItemProps<NodeType>): JSX.Element;
    propTypes: {
        children: PropTypes.Validator<(...args: any[]) => any>;
        original: PropTypes.Requireable<string>;
        originalSrcset: PropTypes.Requireable<string>;
        thumbnail: PropTypes.Requireable<string>;
        width: PropTypes.Requireable<NonNullable<string | number | null | undefined>>;
        height: PropTypes.Requireable<NonNullable<string | number | null | undefined>>;
        alt: PropTypes.Requireable<string>;
        caption: PropTypes.Requireable<string>;
        content: PropTypes.Requireable<PropTypes.ReactElementLike>;
        html: PropTypes.Requireable<string>;
        id: PropTypes.Requireable<NonNullable<string | number | null | undefined>>;
        cropped: PropTypes.Requireable<boolean>;
        sourceId: PropTypes.Requireable<NonNullable<string | number | null | undefined>>;
    };
};
